All patches and comments are welcome. Please squash your changes to logical
commits before using git-format-patch and git-send-email to
patches@git.madduck.net.
If you'd read over the Git project's submission guidelines and adhered to them,
I'd be especially grateful.
5 mr - a Multiple Repository management tool
9 B<mr> [options] checkout
11 B<mr> [options] update
13 B<mr> [options] status
15 B<mr> [options] commit [-m "message"]
17 B<mr> [options] record [-m "message"]
25 B<mr> [options] run command [param ...]
27 B<mr> [options] bootstrap url [directory]
29 B<mr> [options] register [repository]
31 B<mr> [options] config section ["parameter=[value]" ...]
33 B<mr> [options] action [params ...]
35 B<mr> [options] [online|offline]
37 B<mr> [options] remember action [params ...]
41 B<mr> is a Multiple Repository management tool. It can checkout, update, or
42 perform other actions on a set of repositories as if they were one combined
43 repository. It supports any combination of subversion, git, cvs, mercurial,
44 bzr, darcs and fossil repositories, and support for other revision
45 control systems can easily be added.
47 B<mr> cds into and operates on all registered repositories at or below your
48 working directory. Or, if you are in a subdirectory of a repository that
49 contains no other registered repositories, it will stay in that directory,
50 and work on only that repository,
52 B<mr> is configured by .mrconfig files, which list the repositories. It
53 starts by reading the .mrconfig file in your home directory, and this can
54 in turn chain load .mrconfig files from repositories. It also automatically
55 looks for a .mrconfig file in the current directory, or in one of its
58 These predefined commands should be fairly familiar to users of any revision
63 =item checkout (or co)
65 Checks out any repositories that are not already checked out.
69 Updates each repository from its configured remote repository.
71 If a repository isn't checked out yet, it will first check it out.
75 Displays a status report for each repository, showing what
76 uncommitted changes are present in the repository.
80 Commits changes to each repository. (By default, changes are pushed to the
81 remote repository too, when using distributed systems like git. If you
82 don't like this default, you can change it in your .mrconfig, or use record
85 The optional -m parameter allows specifying a commit message.
89 Records changes to the local repository, but does not push them to the
90 remote repository. Only supported for distributed revision control systems.
92 The optional -m parameter allows specifying a commit message.
96 Pushes committed local changes to the remote repository. A no-op for
97 centralized revision control systems.
101 Show a diff of uncommitted changes.
107 =item run command [param ...]
109 Runs the specified command in each repository.
113 These commands are also available:
117 =item bootstrap url [directory]
119 Causes mr to download the url, and use it as a .mrconfig file
120 to checkout the repositories listed in it, into the specified directory.
122 The directory will be created if it does not exist. If no directory is
123 specified, the current directory will be used.
125 If the .mrconfig file includes a repository named ".", that
126 is checked out into the top of the specified directory.
130 List the repositories that mr will act on.
134 Register an existing repository in a mrconfig file. By default, the
135 repository in the current directory is registered, or you can specify a
136 directory to register.
138 The mrconfig file that is modified is chosen by either the -c option, or by
139 looking for the closest known one at or in a parent of the current directory.
143 Adds, modifies, removes, or prints a value from a mrconfig file. The next
144 parameter is the name of the section the value is in. To add or modify
145 values, use one or more instances of "parameter=value". Use "parameter=" to
146 remove a parameter. Use just "parameter" to get the value of a parameter.
148 For example, to add (or edit) a repository in src/foo:
150 mr config src/foo checkout="svn co svn://example.com/foo/trunk foo"
152 To show the command that mr uses to update the repository in src/foo:
154 mr config src/foo update
156 To see the built-in library of shell functions contained in mr:
158 mr config DEFAULT lib
160 The mrconfig file that is used is chosen by either the -c option, or by
161 looking for the closest known one at or in a parent of the current directory.
165 Advises mr that it is in offline mode. Any commands that fail in
166 offline mode will be remembered, and retried when mr is told it's online.
170 Advices mr that it is in online mode again. Commands that failed while in
171 offline mode will be re-run.
175 Remember a command, to be run later when mr re-enters online mode. This
176 implicitly puts mr into offline mode. The command can be any regular mr
177 command. This is useful when you know that a command will fail due to being
178 offline, and so don't want to run it right now at all, but just remember
179 to run it when you go back online.
187 Actions can be abbreviated to any unambiguous substring, so
188 "mr st" is equivalent to "mr status", and "mr up" is equivalent to "mr
191 Additional parameters can be passed to most commands, and are passed on
192 unchanged to the underlying revision control system. This is mostly useful
193 if the repositories mr will act on all use the same revision control
202 =item --directory directory
204 Specifies the topmost directory that B<mr> should work in. The default is
205 the current working directory.
209 =item --config mrconfig
211 Use the specified mrconfig file. The default is to use both B<~/.mrconfig>
212 as well as look for a .mrconfig file in the current directory, or in one
213 of its parent directories.
225 Be quiet. This supresses mr's usual output, as well as any output from
226 commands that are run (including stderr output). If a command fails,
227 the output will be shown.
233 Accept untrusted SSL certificates when bootstrapping.
239 Expand the statistics line displayed at the end to include information
240 about exactly which repositories failed and were skipped, if any.
246 Interactive mode. If a repository fails to be processed, a subshell will be
247 started which you can use to resolve or investigate the problem. Exit the
248 subshell to continue the mr run.
252 =item --no-recurse [number]
254 If no number if specified, just operate on the repository for the current
255 directory, do not recurse into deeper repositories.
257 If a number is specified, will recurse into repositories at most that many
258 subdirectories deep. For example, with -n 2 it would recurse into ./src/foo,
259 but not ./src/packages/bar.
263 =item --jobs [number]
265 Run the specified number of jobs in parallel, or an unlimited number of jobs
266 with no number specified. This can greatly speed up operations such as updates.
267 It is not recommended for interactive operations.
269 Note that running more than 10 jobs at a time is likely to run afoul of
270 ssh connection limits. Running between 3 and 5 jobs at a time will yield
271 a good speedup in updates without loading the machine too much.
277 Trust all mrconfig files even if they are not listed in ~/.mrtrust.
284 This obsolete flag is ignored.
288 =head1 MRCONFIG FILES
290 Here is an example .mrconfig file:
293 checkout = svn checkout svn://svn.example.com/src/trunk src
297 checkout = git clone git://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux-2.6.git &&
299 git checkout -b mybranch origin/master
301 The .mrconfig file uses a variant of the INI file format. Lines starting with
302 "#" are comments. Values can be continued to the following line by
303 indenting the line with whitespace.
305 The "DEFAULT" section allows setting default values for the sections that
308 The "ALIAS" section allows adding aliases for actions. Each parameter
309 is an alias, and its value is the action to use.
311 All other sections add repositories. The section header specifies the
312 directory where the repository is located. This is relative to the directory
313 that contains the mrconfig file, but you can also choose to use absolute
314 paths. (Note that you can use environment variables in section names; they
315 will be passed through the shell for expansion. For example,
316 "[$HOSTNAME]", or "[${HOSTNAME}foo]")
318 Within a section, each parameter defines a shell command to run to handle a
319 given action. mr contains default handlers for "update", "status",
320 "commit", and other standard actions.
322 Normally you only need to specify what to do for "checkout". Here you
323 specify the command to run in order to create a checkout of the repository.
324 The command will be run in the parent directory, and must create the
325 repository's directory. So use "git clone", "svn checkout", "bzr branch"
326 or "bzr checkout" (for a bound branch), etc.
328 Note that these shell commands are run in a "set -e" shell
329 environment, where any additional parameters you pass are available in
330 "$@". All commands other than "checkout" are run inside the repository,
331 though not necessarily at the top of it.
333 The "MR_REPO" environment variable is set to the path to the top of the
334 repository. (For the "register" action, "MR_REPO" is instead set to the
335 basename of the directory that should be created when checking the
338 The "MR_CONFIG" environment variable is set to the .mrconfig file
339 that defines the repo being acted on, or, if the repo is not yet in a config
340 file, the .mrconfig file that should be modified to register the repo.
342 A few parameters have special meanings:
348 If the "skip" parameter is set and its command returns true, then B<mr>
349 will skip acting on that repository. The command is passed the action
352 Here are two examples. The first skips the repo unless
353 mr is run by joey. The second uses the hours_since function
354 (included in mr's built-in library) to skip updating the repo unless it's
355 been at least 12 hours since the last update.
357 skip = test `whoami` != joey
358 skip = [ "$1" = update ] && ! hours_since "$1" 12
362 The "order" parameter can be used to override the default ordering of
363 repositories. The default order value is 10. Use smaller values to make
364 repositories be processed earlier, and larger values to make repositories
367 Note that if a repository is located in a subdirectory of another
368 repository, ordering it to be processed earlier is not recommended.
372 If the "chain" parameter is set and its command returns true, then B<mr>
373 will try to load a .mrconfig file from the root of the repository.
377 If the "include" parameter is set, its command is ran, and should output
378 additional mrconfig file content. The content is included as if it were
379 part of the including file.
381 Unlike all other parameters, this parameter does not need to be placed
386 If the "deleted" parameter is set and its command returns true, then
387 B<mr> will treat the repository as deleted. It won't ever actually delete
388 the repository, but it will warn if it sees the repository's directory.
389 This is useful when one mrconfig file is shared amoung multiple machines,
390 to keep track of and remember to delete old repositories.
394 The "lib" parameter can specify some shell code that will be run before each
395 command, this can be a useful way to define shell functions for other commands
400 If the "fixups" parameter is set, its command is run whenever a repository
401 is checked out, or updated. This provides an easy way to do things
402 like permissions fixups, or other tweaks to the repository content,
403 whenever the repository is changed.
407 If a "pre_action" parameter is set, its command is run before mr performs the
408 specified action. Similarly, "post_action" parameters are run after mr
409 successfully performs the specified action. For example, "pre_commit" is
410 run before committing; "post_update" is run after updating.
414 When looking for a command to run for a given action, mr first looks for
415 a parameter with the same name as the action. If that is not found, it
416 looks for a parameter named "rcs_action" (substituting in the name of the
417 revision control system and the action). The name of the revision control
418 system is itself determined by running each defined "rcs_test" action,
421 Internally, mr has settings for "git_update", "svn_update", etc. To change
422 the action that is performed for a given revision control system, you can
423 override these rcs specific actions. To add a new revision control system,
424 you can just add rcs specific actions for it.
426 =head1 UNTRUSTED MRCONFIG FILES
428 Since mrconfig files can contain arbitrary shell commands, they can do
429 anything. This flexibility is good, but it also allows a malicious mrconfig
430 file to delete your whole home directory. Such a file might be contained
431 inside a repository that your main ~/.mrconfig checks out. To
432 avoid worries about evil commands in a mrconfig file, mr defaults to
433 reading all mrconfig files other than the main ~/.mrconfig in untrusted
434 mode. In untrusted mode, mrconfig files are limited to running only known
435 safe commands (like "git clone") in a carefully checked manner.
437 To configure mr to trust other mrconfig files, list them in ~/.mrtrust.
438 One mrconfig file should be listed per line. Either the full pathname
439 should be listed, or the pathname can start with "~/" to specify a file
440 relative to your home directory.
442 =head1 OFFLINE LOG FILE
444 The ~/.mrlog file contains commands that mr has remembered to run later,
445 due to being offline. You can delete or edit this file to remove commands,
446 or even to add other commands for 'mr online' to run. If the file is
447 present, mr assumes it is in offline mode.
451 mr can be extended to support things such as unison and git-svn. Some
452 files providing such extensions are available in /usr/share/mr/. See
453 the documentation in the files for details about using them.
457 mr returns nonzero if a command failed in any of the repositories.
461 Copyright 2007-2011 Joey Hess <joey@kitenet.net>
463 Licensed under the GNU GPL version 2 or higher.
465 http://kitenet.net/~joey/code/mr/
472 use Cwd qw(getcwd abs_path);
474 # things that can happen when mr runs a command
483 my $config_overridden=0;
493 my $directory=getcwd();
495 $ENV{MR_CONFIG}=find_mrconfig();
502 my (@ok, @failed, @skipped);
508 my ($action, $dir, $topdir, $subdir) = @_;
510 if (exists $rcs{$dir}) {
515 foreach my $rcs_test (
517 length $a <=> length $b
520 } grep { /_test$/ } keys %{$config{$topdir}{$subdir}}) {
521 my ($rcs)=$rcs_test=~/(.*)_test/;
522 $test="my_$rcs_test() {\n$config{$topdir}{$subdir}{$rcs_test}\n}\n".$test;
523 $test.="if my_$rcs_test; then echo $rcs; fi\n";
525 $test=$config{$topdir}{$subdir}{lib}."\n".$test
526 if exists $config{$topdir}{$subdir}{lib};
528 print "mr $action: running rcs test >>$test<<\n" if $verbose;
533 print STDERR "mr $action: found multiple possible repository types ($rcs) for ".fulldir($topdir, $subdir)."\n";
537 return $rcs{$dir}=undef;
540 return $rcs{$dir}=$rcs;
545 my ($action, $dir, $topdir, $subdir, $is_checkout) = @_;
547 if (exists $config{$topdir}{$subdir}{$action}) {
548 return $config{$topdir}{$subdir}{$action};
555 my $rcs=rcs_test(@_);
558 exists $config{$topdir}{$subdir}{$rcs."_".$action}) {
559 return $config{$topdir}{$subdir}{$rcs."_".$action};
567 my ($topdir, $subdir) = @_;
568 return $subdir =~ /^\// ? $subdir : $topdir.$subdir;
572 my ($action, $dir, $topdir, $subdir, $force_checkout) = @_;
573 my $fulldir=fulldir($topdir, $subdir);
575 $ENV{MR_CONFIG}=$configfiles{$topdir};
576 my $lib=exists $config{$topdir}{$subdir}{lib} ?
577 $config{$topdir}{$subdir}{lib}."\n" : "";
578 my $is_checkout=($action eq 'checkout');
579 my $is_update=($action =~ /update/);
583 foreach my $testname ("skip", "deleted") {
584 my $testcommand=findcommand($testname, $dir, $topdir, $subdir, $is_checkout);
586 if (defined $testcommand) {
587 my $test="set -e;".$lib.
588 "my_action(){ $testcommand\n }; my_action '$action'";
589 print "mr $action: running $testname test >>$test<<\n" if $verbose;
590 my $ret=system($test);
592 if (($? & 127) == 2) {
593 print STDERR "mr $action: interrupted\n";
597 print STDERR "mr $action: $testname test received signal ".($? & 127)."\n";
601 if ($ret >> 8 == 0) {
602 if ($testname eq "deleted") {
604 print STDERR "mr error: $dir should be deleted yet still exists\n";
608 print "mr $action: skip $dir skipped\n" if $verbose;
615 if (! $force_checkout) {
617 print "mr $action: $dir already exists, skipping checkout\n" if $verbose;
621 $dir=~s/^(.*)\/[^\/]+\/?$/$1/;
626 return action("checkout", $dir, $topdir, $subdir);
630 my $command=findcommand($action, $dir, $topdir, $subdir, $is_checkout);
632 if ($is_checkout && ! -d $dir) {
633 print "mr $action: creating parent directory $dir\n" if $verbose;
634 system("mkdir", "-p", $dir);
637 if (! $no_chdir && ! chdir($dir)) {
638 print STDERR "mr $action: failed to chdir to $dir: $!\n";
641 elsif (! defined $command) {
642 my $rcs=rcs_test(@_);
643 if (! defined $rcs) {
644 print STDERR "mr $action: unknown repository type and no defined $action command for $fulldir\n";
648 print STDERR "mr $action: no defined action for $rcs repository $fulldir, skipping\n";
655 $actionmsg="mr $action: $fulldir";
659 $s=~s/^\Q$fulldir\E\/?//;
660 $actionmsg="mr $action: $fulldir (in subdir $s)";
662 print "$actionmsg\n" unless $quiet;
664 my $hookret=hook("pre_$action", $topdir, $subdir);
665 return $hookret if $hookret != OK;
667 $command="set -e; ".$lib.
668 "my_action(){ $command\n }; my_action ".
669 join(" ", map { s/\\/\\\\/g; s/"/\"/g; '"'.$_.'"' } @ARGV);
670 print "mr $action: running >>$command<<\n" if $verbose;
673 my $output = qx/$command 2>&1/;
676 print "$actionmsg\n";
677 print STDERR $output;
681 $ret=system($command);
684 if (($? & 127) == 2) {
685 print STDERR "mr $action: interrupted\n";
689 print STDERR "mr $action: received signal ".($? & 127)."\n";
692 print STDERR "mr $action: failed ($ret)\n" if $verbose;
693 if ($ret >> 8 != 0) {
694 print STDERR "mr $action: command failed\n";
695 if (-e "$ENV{HOME}/.mrlog" && $action ne 'remember') {
696 # recreate original command line to
697 # remember, and avoid recursing
699 @ARGV=('-n', $action, @orig);
700 action("remember", $dir, $topdir, $subdir);
705 print STDERR "mr $action: command died ($ret)\n";
710 if ($is_checkout && ! -d $dir) {
711 print STDERR "mr $action: $dir missing after checkout\n";;
715 my $ret=hook("post_$action", $topdir, $subdir);
716 return $ret if $ret != OK;
718 if (($is_checkout || $is_update)) {
719 my $ret=hook("fixups", $topdir, $subdir);
720 return $ret if $ret != OK;
729 my ($hook, $topdir, $subdir) = @_;
731 my $command=$config{$topdir}{$subdir}{$hook};
732 return OK unless defined $command;
733 my $lib=exists $config{$topdir}{$subdir}{lib} ?
734 $config{$topdir}{$subdir}{lib}."\n" : "";
735 my $shell="set -e;".$lib.
736 "my_hook(){ $command\n }; my_hook";
737 print "mr $hook: running >>$shell<<\n" if $verbose;
740 my $output = qx/$shell 2>&1/;
743 print STDERR $output;
750 if (($? & 127) == 2) {
751 print STDERR "mr $hook: interrupted\n";
755 print STDERR "mr $hook: received signal ".($? & 127)."\n";
763 # run actions on multiple repos, in parallel
773 while (@fhs or @repos) {
774 while ((!$jobs || $running < $jobs) && @repos) {
776 my $repo = shift @repos;
777 pipe(my $outfh, CHILD_STDOUT);
778 pipe(my $errfh, CHILD_STDERR);
780 unless ($pid = fork) {
781 die "mr $action: cannot fork: $!" unless defined $pid;
782 open(STDOUT, ">&CHILD_STDOUT") || die "mr $action cannot reopen stdout: $!";
783 open(STDERR, ">&CHILD_STDERR") || die "mr $action cannot reopen stderr: $!";
788 exit action($action, @$repo);
792 push @active, [$pid, $repo];
793 push @fhs, [$outfh, $errfh];
796 my ($rin, $rout) = ('','');
798 foreach my $fh (@fhs) {
799 next unless defined $fh;
800 vec($rin, fileno($fh->[0]), 1) = 1 if defined $fh->[0];
801 vec($rin, fileno($fh->[1]), 1) = 1 if defined $fh->[1];
803 $nfound = select($rout=$rin, undef, undef, 1);
804 foreach my $channel (0, 1) {
805 foreach my $i (0..$#fhs) {
806 next unless defined $fhs[$i];
807 my $fh = $fhs[$i][$channel];
808 next unless defined $fh;
809 if (vec($rout, fileno($fh), 1) == 1) {
811 if (sysread($fh, $r, 1024) == 0) {
813 $fhs[$i][$channel] = undef;
814 if (! defined $fhs[$i][0] &&
815 ! defined $fhs[$i][1]) {
816 waitpid($active[$i][0], 0);
817 print STDOUT $out[$i][0];
818 print STDERR $out[$i][1];
819 record($active[$i][1], $? >> 8);
821 splice(@active, $i, 1);
826 $out[$i][$channel] .= $r;
834 my $dir=shift()->[0];
839 print "\n" unless $quiet;
841 elsif ($ret == FAILED) {
843 chdir($dir) unless $no_chdir;
844 print STDERR "mr: Starting interactive shell. Exit shell to continue.\n";
845 system((getpwuid($<))[8], "-i");
848 print "\n" unless $quiet;
850 elsif ($ret == SKIPPED) {
853 elsif ($ret == ABORT) {
857 die "unknown exit status $ret";
863 if (! @ok && ! @failed && ! @skipped) {
864 die "mr $action: no repositories found to work on\n";
866 print "mr $action: finished (".join("; ",
867 showstat($#ok+1, "ok", "ok"),
868 showstat($#failed+1, "failed", "failed"),
869 showstat($#skipped+1, "skipped", "skipped"),
870 ).")\n" unless $quiet;
873 print "mr $action: (skipped: ".join(" ", @skipped).")\n" unless $quiet;
876 print STDERR "mr $action: (failed: ".join(" ", @failed).")\n";
886 return "$count ".($count > 1 ? $plural : $singular);
891 # an ordered list of repos
894 foreach my $topdir (sort keys %config) {
895 foreach my $subdir (sort keys %{$config{$topdir}}) {
899 order => $config{$topdir}{$subdir}{order},
904 $a->{order} <=> $b->{order}
906 $a->{topdir} cmp $b->{topdir}
908 $a->{subdir} cmp $b->{subdir}
914 my $topdir=$repo->{topdir};
915 my $subdir=$repo->{subdir};
916 my $ret=($subdir =~/^\//) ? $subdir : $topdir.$subdir;
921 # figure out which repos to act on
924 foreach my $repo (repolist()) {
925 my $topdir=$repo->{topdir};
926 my $subdir=$repo->{subdir};
928 next if $subdir eq 'DEFAULT';
929 my $dir=repodir($repo);
931 $dir.="/" unless $dir=~/\/$/;
932 $d.="/" unless $d=~/\/$/;
933 next if $dir ne $d && $dir !~ /^\Q$d\E/;
934 if (defined $max_depth) {
935 my @a=split('/', $dir);
936 my @b=split('/', $d);
937 do { } while (@a && @b && shift(@a) eq shift(@b));
938 next if @a > $max_depth || @b > $max_depth;
940 push @repos, [$dir, $topdir, $subdir];
943 # fallback to find a leaf repo
944 foreach my $repo (reverse repolist()) {
945 my $topdir=$repo->{topdir};
946 my $subdir=$repo->{subdir};
948 next if $subdir eq 'DEFAULT';
949 my $dir=repodir($repo);
951 $dir.="/" unless $dir=~/\/$/;
952 $d.="/" unless $d=~/\/$/;
953 if ($d=~/^\Q$dir\E/) {
954 push @repos, [$dir, $topdir, $subdir];
976 sub is_trusted_config {
977 my $config=shift; # must be abs_pathed already
979 # We always trust ~/.mrconfig.
980 return 1 if $config eq abs_path("$ENV{HOME}/.mrconfig");
982 return 1 if $trust_all;
984 my $trustfile=$ENV{HOME}."/.mrtrust";
987 $trusted{"$ENV{HOME}/.mrconfig"}=1;
988 if (open (TRUST, "<", $trustfile)) {
991 s/^~\//$ENV{HOME}\//;
992 $trusted{abs_path($_)}=1;
998 return $trusted{$config};
1002 sub is_trusted_repo {
1005 # Tightly limit what is allowed in a repo name.
1006 # No ../, no absolute paths, and no unusual filenames
1007 # that might try to escape to the shell.
1008 return $repo =~ /^[-_.+\/A-Za-z0-9]+$/ &&
1009 $repo !~ /\.\./ && $repo !~ /^\//;
1012 sub is_trusted_checkout {
1015 # To determine if the command is safe, compare it with the
1016 # *_trusted_checkout config settings. Those settings are
1017 # templates for allowed commands, so make sure that each word
1018 # of the command matches the corresponding word of the template.
1021 foreach my $word (split(' ', $command)) {
1023 if ($word=~/^'(.*)'$/) {
1026 elsif ($word=~/^"(.*)"$/) {
1033 foreach my $key (grep { /_trusted_checkout$/ }
1034 keys %{$config{''}{DEFAULT}}) {
1035 my @twords=split(' ', $config{''}{DEFAULT}{$key});
1036 next if @words > @twords;
1040 for (my $c=0; $c < @twords && $match; $c++) {
1041 if ($twords[$c] eq '$url') {
1042 # Match all the typical characters found in
1043 # urls, plus @ which svn can use. Note
1044 # that the "url" might also be a local
1047 defined $words[$c] &&
1048 $words[$c] =~ /^[-_.+:@\/A-Za-z0-9]+$/
1052 elsif ($twords[$c] eq '$repo') {
1053 # If a repo is not specified, assume it
1054 # will be the last path component of the
1055 # url, or something derived from it, and
1057 if (! defined $words[$c] && defined $url) {
1058 ($words[$c])=$url=~/\/([^\/]+)\/?$/;
1062 defined $words[$c] &&
1063 is_trusted_repo($words[$c])
1066 elsif (defined $words[$c] && $words[$c]=~/^($twords[$c])$/) {
1080 my ($err, $file, $line, $url)=@_;
1083 die "$err in untrusted $url line $line\n".
1084 "(To trust this url, --trust-all can be used; but please use caution;\n".
1085 "this can allow arbitrary code execution!)\n";
1088 die "$err in untrusted $file line $line\n".
1089 "(To trust this file, list it in ~/.mrtrust.)\n";
1097 my $bootstrap_url=shift;
1103 if (ref $f eq 'GLOB') {
1109 my $absf=abs_path($f);
1110 if ($loaded{$absf}) {
1115 $trusted=is_trusted_config($absf);
1117 if (! defined $dir) {
1118 ($dir)=$f=~/^(.*\/)[^\/]+$/;
1119 if (! defined $dir) {
1124 $dir=abs_path($dir)."/";
1126 if (! exists $configfiles{$dir}) {
1127 $configfiles{$dir}=$f;
1130 # copy in defaults from first parent
1132 while ($parent=~s/^(.*\/)[^\/]+\/?$/$1/) {
1133 if ($parent eq '/') {
1136 if (exists $config{$parent} &&
1137 exists $config{$parent}{DEFAULT}) {
1138 $config{$dir}{DEFAULT}={ %{$config{$parent}{DEFAULT}} };
1147 print "mr: loading config $f\n" if $verbose;
1148 open($in, "<", $f) || die "mr: open $f: $!\n";
1151 close $in unless ref $f eq 'GLOB';
1159 next if /^\s*\#/ || /^\s*$/;
1160 if (/^\[([^\]]*)\]\s*$/) {
1164 if (! is_trusted_repo($section) ||
1165 $section eq 'ALIAS' ||
1166 $section eq 'DEFAULT') {
1167 trusterror("mr: illegal section \"[$section]\"", $f, $line, $bootstrap_url)
1170 $section=expandenv($section) if $trusted;
1171 if ($section ne 'ALIAS' &&
1172 ! exists $config{$dir}{$section} &&
1173 exists $config{$dir}{DEFAULT}) {
1175 $config{$dir}{$section}={ %{$config{$dir}{DEFAULT}} };
1178 elsif (/^(\w+)\s*=\s*(.*)/) {
1183 while (@lines && $lines[0]=~/^\s(.+)/) {
1191 # Untrusted files can only contain a few
1192 # settings in specific known-safe formats.
1193 if ($parameter eq 'checkout') {
1194 if (! is_trusted_checkout($value)) {
1195 trusterror("mr: illegal checkout command \"$value\"", $f, $line, $bootstrap_url);
1198 elsif ($parameter eq 'order') {
1199 # not interpreted as a command, so
1202 elsif ($value eq 'true' || $value eq 'false') {
1203 # skip=true , deleted=true etc are
1207 trusterror("mr: illegal setting \"$parameter=$value\"", $f, $line, $bootstrap_url);
1211 if ($parameter eq "include") {
1212 print "mr: including output of \"$value\"\n" if $verbose;
1213 unshift @lines, `$value`;
1215 print STDERR "mr: include command exited nonzero ($?)\n";
1220 if (! defined $section) {
1221 die "$f line $.: parameter ($parameter) not in section\n";
1223 if ($section eq 'ALIAS') {
1224 $alias{$parameter}=$value;
1226 elsif ($parameter eq 'lib') {
1227 $config{$dir}{$section}{lib}.=$value."\n";
1230 $config{$dir}{$section}{$parameter}=$value;
1231 if ($parameter =~ /.*_(.*)/) {
1232 $knownactions{$1}=1;
1235 $knownactions{$parameter}=1;
1237 if ($parameter eq 'chain' &&
1238 length $dir && $section ne "DEFAULT" &&
1239 -e $dir.$section."/.mrconfig") {
1240 my $ret=system($value);
1242 if (($? & 127) == 2) {
1243 print STDERR "mr: chain test interrupted\n";
1247 print STDERR "mr: chain test received signal ".($? & 127)."\n";
1251 push @toload, $dir.$section."/.mrconfig";
1257 die "$f line $line: parse error\n";
1266 sub startingconfig {
1267 %alias=%config=%configfiles=%knownactions=%loaded=();
1268 my $datapos=tell(DATA);
1270 seek(DATA,$datapos,0); # rewind
1275 # the section to modify or add
1276 my $targetsection=shift;
1277 # fields to change in the section
1278 # To remove a field, set its value to "".
1279 my %changefields=@_;
1285 open(my $in, "<", $f) || die "mr: open $f: $!\n";
1290 my $formatfield=sub {
1292 my @value=split(/\n/, shift);
1294 return "$field = ".shift(@value)."\n".
1295 join("", map { "\t$_\n" } @value);
1299 while ($out[$#out] =~ /^\s*$/) {
1300 unshift @blanks, pop @out;
1302 foreach my $field (sort keys %changefields) {
1303 if (length $changefields{$field}) {
1304 push @out, "$field = $changefields{$field}\n";
1305 delete $changefields{$field};
1315 if (/^\s*\#/ || /^\s*$/) {
1318 elsif (/^\[([^\]]*)\]\s*$/) {
1319 if (defined $section &&
1320 $section eq $targetsection) {
1324 $section=expandenv($1);
1328 elsif (/^(\w+)\s*=\s(.*)/) {
1333 while (@lines && $lines[0]=~/^\s(.+)/) {
1339 if ($section eq $targetsection) {
1340 if (exists $changefields{$parameter}) {
1341 if (length $changefields{$parameter}) {
1342 $value=$changefields{$parameter};
1344 delete $changefields{$parameter};
1348 push @out, $formatfield->($parameter, $value);
1352 if (defined $section &&
1353 $section eq $targetsection) {
1356 elsif (%changefields) {
1357 push @out, "\n[$targetsection]\n";
1358 foreach my $field (sort keys %changefields) {
1359 if (length $changefields{$field}) {
1360 push @out, $formatfield->($field, $changefields{$field});
1365 open(my $out, ">", $f) || die "mr: write $f: $!\n";
1373 # actions that do not operate on all repos
1374 if ($action eq 'help') {
1377 elsif ($action eq 'config') {
1380 elsif ($action eq 'register') {
1383 elsif ($action eq 'bootstrap') {
1386 elsif ($action eq 'remember' ||
1387 $action eq 'offline' ||
1388 $action eq 'online') {
1389 my @repos=selectrepos;
1390 action($action, @{$repos[0]}) if @repos;
1394 if (!$jobs || $jobs > 1) {
1395 mrs($action, selectrepos());
1398 foreach my $repo (selectrepos()) {
1399 record($repo, action($action, @$repo));
1405 exec($config{''}{DEFAULT}{help}) || die "exec: $!";
1410 die "mr config: not enough parameters\n";
1413 if ($section=~/^\//) {
1414 # try to convert to a path relative to the config file
1415 my ($dir)=$ENV{MR_CONFIG}=~/^(.*\/)[^\/]+$/;
1416 $dir=abs_path($dir);
1417 $dir.="/" unless $dir=~/\/$/;
1418 if ($section=~/^\Q$dir\E(.*)/) {
1424 if (/^([^=]+)=(.*)$/) {
1425 $changefields{$1}=$2;
1429 foreach my $topdir (sort keys %config) {
1430 if (exists $config{$topdir}{$section} &&
1431 exists $config{$topdir}{$section}{$_}) {
1432 print $config{$topdir}{$section}{$_}."\n";
1434 last if $section eq 'DEFAULT';
1438 die "mr config: $section $_ not set\n";
1442 modifyconfig($ENV{MR_CONFIG}, $section, %changefields) if %changefields;
1447 if ($config_overridden) {
1448 # Find the directory that the specified config file is
1450 ($directory)=abs_path($ENV{MR_CONFIG})=~/^(.*\/)[^\/]+$/;
1453 # Find the closest known mrconfig file to the current
1455 $directory.="/" unless $directory=~/\/$/;
1457 foreach my $topdir (reverse sort keys %config) {
1458 next unless length $topdir;
1459 if ($directory=~/^\Q$topdir\E/) {
1460 $ENV{MR_CONFIG}=$configfiles{$topdir};
1466 if (! $foundconfig) {
1467 $directory=""; # no config file, use builtin
1471 my $subdir=shift @ARGV;
1472 if (! chdir($subdir)) {
1473 print STDERR "mr register: failed to chdir to $subdir: $!\n";
1477 $ENV{MR_REPO}=getcwd();
1478 my $command=findcommand("register", $ENV{MR_REPO}, $directory, 'DEFAULT', 0);
1479 if (! defined $command) {
1480 die "mr register: unknown repository type\n";
1483 $ENV{MR_REPO}=~s/.*\/(.*)/$1/;
1484 $command="set -e; ".$config{$directory}{DEFAULT}{lib}."\n".
1485 "my_action(){ $command\n }; my_action ".
1486 join(" ", map { s/\\/\\\\/g; s/"/\"/g; '"'.$_.'"' } @ARGV);
1487 print "mr register: running >>$command<<\n" if $verbose;
1488 exec($command) || die "exec: $!";
1492 my $url=shift @ARGV;
1493 my $dir=shift @ARGV || ".";
1495 if (! defined $url || ! length $url) {
1496 die "mr: bootstrap requires url\n";
1499 # Download the config file to a temporary location.
1500 eval q{use File::Temp};
1502 my $tmpconfig=File::Temp->new();
1503 my @curlargs = ("curl", "-A", "mr", "-L", "-s", $url, "-o", $tmpconfig);
1504 push(@curlargs, "-k") if $insecure;
1505 my $curlstatus = system(@curlargs);
1506 die "mr bootstrap: invalid SSL certificate for $url (consider -k)\n" if $curlstatus >> 8 == 60;
1507 die "mr bootstrap: download of $url failed\n" if $curlstatus != 0;
1510 system("mkdir", "-p", $dir);
1512 chdir($dir) || die "chdir $dir: $!";
1514 # Special case to handle checkout of the "." repo, which
1515 # would normally be skipped.
1516 my $topdir=abs_path(".")."/";
1517 my @repo=($topdir, $topdir, ".");
1518 loadconfig($tmpconfig, $topdir, $url);
1519 record(\@repo, action("checkout", @repo, 1))
1520 if exists $config{$topdir}{"."}{"checkout"};
1522 if (-e ".mrconfig") {
1523 print STDERR "mr bootstrap: .mrconfig file already exists, not overwriting with $url\n";
1526 eval q{use File::Copy};
1528 move($tmpconfig, ".mrconfig") || die "rename: $!";
1531 # Reload the config file (in case we got a different version)
1532 # and checkout everything else.
1534 loadconfig(".mrconfig");
1535 dispatch("checkout");
1536 @skipped=grep { abs_path($_) ne abs_path($topdir) } @skipped;
1537 showstats("bootstrap");
1541 # alias expansion and command stemming
1544 if (exists $alias{$action}) {
1545 $action=$alias{$action};
1547 if (! exists $knownactions{$action}) {
1548 my @matches = grep { /^\Q$action\E/ }
1549 keys %knownactions, keys %alias;
1550 if (@matches == 1) {
1551 $action=$matches[0];
1553 elsif (@matches == 0) {
1554 die "mr: unknown action \"$action\" (known actions: ".
1555 join(", ", sort keys %knownactions).")\n";
1558 die "mr: ambiguous action \"$action\" (matches: ".
1559 join(", ", @matches).")\n";
1567 while (length $dir) {
1568 if (-e "$dir/.mrconfig") {
1569 return "$dir/.mrconfig";
1571 $dir=~s/\/[^\/]*$//;
1573 return "$ENV{HOME}/.mrconfig";
1578 Getopt::Long::Configure("bundling", "no_permute");
1579 my $result=GetOptions(
1580 "d|directory=s" => sub { $directory=abs_path($_[1]) },
1581 "c|config=s" => sub { $ENV{MR_CONFIG}=$_[1]; $config_overridden=1 },
1582 "p|path" => sub { }, # now default, ignore
1583 "v|verbose" => \$verbose,
1584 "q|quiet" => \$quiet,
1585 "s|stats" => \$stats,
1586 "k|insecure" => \$insecure,
1587 "i|interactive" => \$interactive,
1588 "n|no-recurse:i" => \$max_depth,
1589 "j|jobs:i" => \$jobs,
1590 "t|trust-all" => \$trust_all,
1592 if (! $result || @ARGV < 1) {
1593 die("Usage: mr [options] action [params ...]\n".
1594 "(Use mr help for man page.)\n");
1597 $ENV{MR_SWITCHES}="";
1598 foreach my $option (@saved) {
1599 last if $option eq $ARGV[0];
1600 $ENV{MR_SWITCHES}.="$option ";
1606 print STDERR "mr: interrupted\n";
1610 # This can happen if it's run in a directory that was removed
1611 # or other strangeness.
1612 if (! defined $directory) {
1613 die("mr: failed to determine working directory\n");
1615 # Make sure MR_CONFIG is an absolute path, but don't use abs_path since
1616 # the config file might be a symlink to elsewhere, and the directory it's
1617 # in is significant.
1618 if ($ENV{MR_CONFIG} !~ /^\//) {
1619 $ENV{MR_CONFIG}=getcwd()."/".$ENV{MR_CONFIG};
1621 # Try to set MR_PATH to the path to the program.
1623 use FindBin qw($Bin $Script);
1624 $ENV{MR_PATH}=$Bin."/".$Script;
1642 loadconfig("$ENV{HOME}/.mrconfig");
1643 loadconfig($ENV{MR_CONFIG});
1644 #use Data::Dumper; print Dumper(\%config);
1646 my $action=expandaction(shift @ARGV);
1653 # Finally, some useful actions that mr knows about by default.
1654 # These can be overridden in ~/.mrconfig.
1669 echo "mr (warning): $@" >&2
1675 if [ -z "$1" ] || [ -z "$2" ]; then
1676 error "mr: usage: hours_since action num"
1678 for dir in .git .svn .bzr CVS .hg _darcs _FOSSIL_; do
1679 if [ -e "$MR_REPO/$dir" ]; then
1680 flagfile="$MR_REPO/$dir/.mr_last$1"
1684 if [ -z "$flagfile" ]; then
1685 error "cannot determine flag filename"
1687 delta=`perl -wle 'print -f shift() ? int((-M _) * 24) : 9999' "$flagfile"`
1688 if [ "$delta" -lt "$2" ]; then
1696 LANG=C bzr info | egrep -q '^Checkout'
1699 svn_test = test -d "$MR_REPO"/.svn
1700 git_test = test -d "$MR_REPO"/.git
1701 bzr_test = test -d "$MR_REPO"/.bzr
1702 cvs_test = test -d "$MR_REPO"/CVS
1703 hg_test = test -d "$MR_REPO"/.hg
1704 darcs_test = test -d "$MR_REPO"/_darcs
1705 fossil_test = test -f "$MR_REPO"/_FOSSIL_
1707 test -d "$MR_REPO"/refs/heads && test -d "$MR_REPO"/refs/tags &&
1708 test -d "$MR_REPO"/objects && test -f "$MR_REPO"/config &&
1709 test "`GIT_CONFIG="$MR_REPO"/config git config --get core.bare`" = true
1711 svn_update = svn update "$@"
1712 git_update = git pull "$@"
1714 if is_bzr_checkout; then
1717 bzr merge --pull "$@"
1719 cvs_update = cvs update "$@"
1720 hg_update = hg pull "$@" && hg update "$@"
1721 darcs_update = darcs pull -a "$@"
1722 fossil_update = fossil pull "$@"
1724 svn_status = svn status "$@"
1725 git_status = git status -s "$@" || true
1726 bzr_status = bzr status --short "$@"
1727 cvs_status = cvs status "$@"
1728 hg_status = hg status "$@"
1729 darcs_status = darcs whatsnew -ls "$@" || true
1730 fossil_status = fossil changes "$@"
1732 svn_commit = svn commit "$@"
1733 git_commit = git commit -a "$@" && git push --all
1735 if is_bzr_checkout; then
1738 bzr commit "$@" && bzr push
1740 cvs_commit = cvs commit "$@"
1741 hg_commit = hg commit -m "$@" && hg push
1742 darcs_commit = darcs record -a -m "$@" && darcs push -a
1743 fossil_commit = fossil commit "$@"
1745 git_record = git commit -a "$@"
1747 if is_bzr_checkout; then
1748 bzr commit --local "$@"
1752 hg_record = hg commit -m "$@"
1753 darcs_record = darcs record -a -m "$@"
1754 fossil_record = fossil commit "$@"
1757 git_push = git push "$@"
1758 bzr_push = bzr push "$@"
1760 hg_push = hg push "$@"
1761 darcs_push = darcs push -a "$@"
1762 fossil_push = fossil push "$@"
1764 svn_diff = svn diff "$@"
1765 git_diff = git diff "$@"
1766 bzr_diff = bzr diff "$@"
1767 cvs_diff = cvs diff "$@"
1768 hg_diff = hg diff "$@"
1769 darcs_diff = darcs diff -u "$@"
1770 fossil_diff = fossil diff "$@"
1772 svn_log = svn log "$@"
1773 git_log = git log "$@"
1774 bzr_log = bzr log "$@"
1775 cvs_log = cvs log "$@"
1776 hg_log = hg log "$@"
1777 darcs_log = darcs changes "$@"
1778 git_bare_log = git log "$@"
1779 fossil_log = fossil timeline "$@"
1784 url=`LC_ALL=C svn info . | grep -i '^URL:' | cut -d ' ' -f 2`
1785 if [ -z "$url" ]; then
1786 error "cannot determine svn url"
1788 echo "Registering svn url: $url in $MR_CONFIG"
1789 mr -c "$MR_CONFIG" config "`pwd`" checkout="svn co '$url' '$MR_REPO'"
1791 url="`LC_ALL=C git config --get remote.origin.url`" || true
1792 if [ -z "$url" ]; then
1793 error "cannot determine git url"
1795 echo "Registering git url: $url in $MR_CONFIG"
1796 mr -c "$MR_CONFIG" config "`pwd`" checkout="git clone '$url' '$MR_REPO'"
1798 url="`LC_ALL=C bzr info . | egrep -i 'checkout of branch|parent branch' | awk '{print $NF}'`"
1799 if [ -z "$url" ]; then
1800 error "cannot determine bzr url"
1802 echo "Registering bzr url: $url in $MR_CONFIG"
1803 mr -c "$MR_CONFIG" config "`pwd`" checkout="bzr branch '$url' '$MR_REPO'"
1805 repo=`cat CVS/Repository`
1807 if [ -z "$root" ]; then
1808 error "cannot determine cvs root"
1810 echo "Registering cvs repository $repo at root $root"
1811 mr -c "$MR_CONFIG" config "`pwd`" checkout="cvs -d '$root' co -d '$MR_REPO' '$repo'"
1813 url=`hg showconfig paths.default`
1814 echo "Registering mercurial repo url: $url in $MR_CONFIG"
1815 mr -c "$MR_CONFIG" config "`pwd`" checkout="hg clone '$url' '$MR_REPO'"
1817 url=`cat _darcs/prefs/defaultrepo`
1818 echo "Registering darcs repository $url in $MR_CONFIG"
1819 mr -c "$MR_CONFIG" config "`pwd`" checkout="darcs get '$url' '$MR_REPO'"
1821 url="`LC_ALL=C GIT_CONFIG=config git config --get remote.origin.url`" || true
1822 if [ -z "$url" ]; then
1823 error "cannot determine git url"
1825 echo "Registering git url: $url in $MR_CONFIG"
1826 mr -c "$MR_CONFIG" config "`pwd`" checkout="git clone --bare '$url' '$MR_REPO'"
1828 url=`fossil remote-url`
1829 repo=`fossil info | grep repository | sed -e 's/repository:*.//g' -e 's/ //g'`
1830 echo "Registering fossil repository $url in $MR_CONFIG"
1831 mr -c "$MR_CONFIG" config "`pwd`" checkout="mkdir -p '$MR_REPO' && cd '$MR_REPO' && fossil open '$repo'"
1833 svn_trusted_checkout = svn co $url $repo
1834 svn_alt_trusted_checkout = svn checkout $url $repo
1835 git_trusted_checkout = git clone $url $repo
1836 bzr_trusted_checkout = bzr checkout|clone|branch|get $url $repo
1838 hg_trusted_checkout = hg clone $url $repo
1839 darcs_trusted_checkout = darcs get $url $repo
1840 git_bare_trusted_checkout = git clone --bare $url $repo
1841 # fossil: messy to do
1847 SHOWMANFILE="man -f"
1853 SHOWMANFILE="man -l"
1856 if [ ! -e "$MR_PATH" ]; then
1857 error "cannot find program path"
1859 tmp=$(mktemp -t mr.XXXXXXXXXX) || error "mktemp failed"
1860 trap "rm -f $tmp" exit
1861 pod2man -c mr "$MR_PATH" > "$tmp" || error "pod2man failed"
1862 $SHOWMANFILE "$tmp" || error "man failed"
1868 if [ -s ~/.mrlog ]; then
1869 info "running offline commands"
1870 mv -f ~/.mrlog ~/.mrlog.old
1871 if ! sh -e ~/.mrlog.old; then
1872 error "offline command failed; left in ~/.mrlog.old"
1876 info "no offline commands to run"
1881 info "offline mode enabled"
1883 info "remembering command: 'mr $@'"
1884 command="mr -d '$(pwd)' $MR_SWITCHES"
1886 command="$command '$w'"
1888 if [ ! -e ~/.mrlog ] || ! grep -q -F "$command" ~/.mrlog; then
1889 echo "$command" >> ~/.mrlog
1892 ed = echo "A horse is a horse, of course, of course.."
1893 T = echo "I pity the fool."
1894 right = echo "Not found."
1896 # vim:sw=8:sts=0:ts=8:noet